diff -cr cdparanoia-III-alpha9.6.ORIG/main.c cdparanoia-III-alpha9.6/main.c
*** cdparanoia-III-alpha9.6.ORIG/main.c	Wed Aug 18 01:03:10 1999
--- cdparanoia-III-alpha9.6/main.c	Wed Oct 20 00:37:59 1999
***************
*** 554,560 ****
      memset(dispcache,' ',graph);
  }
  
! const char *optstring = "escCn:o:d:g:S:prRwafvqVQhZzYXWBi:";
  
  struct option options [] = {
  	{"stderr-progress",no_argument,NULL,'e'},
--- 554,560 ----
      memset(dispcache,' ',graph);
  }
  
! const char *optstring = "escCn:O:o:d:g:S:prRwafvqVQhZzYXWBi:";
  
  struct option options [] = {
  	{"stderr-progress",no_argument,NULL,'e'},
***************
*** 585,590 ****
--- 585,591 ----
  	{"disable-fragmentation",no_argument,NULL,'F'},
  	{"output-info",required_argument,NULL,'i'},
  	{"never-skip",no_argument,NULL,'z'},
+ 	{"offset",required_argument,NULL,'O'},
  
  	{NULL,0,NULL,0}
  };
***************
*** 628,633 ****
--- 629,636 ----
    /* full paranoia, but allow skipping */
    int paranoia_mode=PARANOIA_MODE_FULL^PARANOIA_MODE_NEVERSKIP; 
  
+   long sector_offset=0;
+ 
    char *info_file=NULL;
    int out;
  
***************
*** 738,743 ****
--- 741,749 ----
        if(info_file)free(info_file);
        info_file=copystring(info_file);
        break;
+     case 'O':
+       sector_offset=atoi(optarg);
+       break;
      default:
        usage(stderr);
        exit(1);
***************
*** 896,901 ****
--- 902,913 ----
      long batch_last;
      int batch_track;
  
+     long disc_first_sector;
+     long disc_last_sector;
+ 
+     disc_first_sector=cdda_disc_firstsector(d);
+     disc_last_sector=cdda_disc_lastsector(d);
+ 
      if(span){
        /* look for the hyphen */ 
        char *span2=strchr(span,'-');
***************
*** 937,944 ****
  	}
        }
      }else{
!       first_sector=cdda_disc_firstsector(d);
!       last_sector=cdda_disc_lastsector(d);
      }
  
      {
--- 949,956 ----
  	}
        }
      }else{
!       first_sector=disc_first_sector;
!       last_sector=disc_last_sector;
      }
  
      {
***************
*** 955,967 ****
  	  exit(1);
  	}
  
        sprintf(buffer,"Ripping from sector %7ld (track %2d [%d:%02d.%02d])\n"
  	      "\t  to sector %7ld (track %2d [%d:%02d.%02d])\n",first_sector,
  	      track1,(int)(off1/(60*75)),(int)((off1/75)%60),(int)(off1%75),
  	      last_sector,
  	      track2,(int)(off2/(60*75)),(int)((off2/75)%60),(int)(off2%75));
        report(buffer);
-       
      }
  
      {
--- 967,986 ----
  	  exit(1);
  	}
  
+       first_sector += sector_offset;
+       last_sector += sector_offset;
+       disc_first_sector += sector_offset;
+       disc_last_sector += sector_offset;
+       if (first_sector < 0) first_sector = 0;
+       if (disc_first_sector < 0) disc_first_sector = 0;
+       
        sprintf(buffer,"Ripping from sector %7ld (track %2d [%d:%02d.%02d])\n"
  	      "\t  to sector %7ld (track %2d [%d:%02d.%02d])\n",first_sector,
  	      track1,(int)(off1/(60*75)),(int)((off1/75)%60),(int)(off1%75),
  	      last_sector,
  	      track2,(int)(off2/(60*75)),(int)((off2/75)%60),(int)(off2%75));
+ 
        report(buffer);
      }
  
      {
***************
*** 974,980 ****
  	cdda_verbose_set(d,CDDA_MESSAGE_LOGIT,CDDA_MESSAGE_LOGIT);
        else
  	cdda_verbose_set(d,CDDA_MESSAGE_FORGETIT,CDDA_MESSAGE_FORGETIT);
!       
        paranoia_seek(p,cursor=first_sector,SEEK_SET);      
  
        /* this is probably a good idea in general */
--- 993,999 ----
  	cdda_verbose_set(d,CDDA_MESSAGE_LOGIT,CDDA_MESSAGE_LOGIT);
        else
  	cdda_verbose_set(d,CDDA_MESSAGE_FORGETIT,CDDA_MESSAGE_FORGETIT);
! 
        paranoia_seek(p,cursor=first_sector,SEEK_SET);      
  
        /* this is probably a good idea in general */
***************
*** 986,1002 ****
  	  batch_first=cursor;
  	  batch_last=
  	    cdda_track_lastsector(d,batch_track=
! 				  cdda_sector_gettrack(d,cursor));
  	  if(batch_last>last_sector)batch_last=last_sector;
  	}else{
  	  batch_first=first_sector;
  	  batch_last=last_sector;
  	  batch_track=-1;
  	}
  	
  	callbegin=batch_first;
  	callend=batch_last;
! 	
  	/* argv[optind] is the span, argv[optind+1] (if exists) is outfile */
  	
  	if(optind+1<argc){
--- 1005,1038 ----
  	  batch_first=cursor;
  	  batch_last=
  	    cdda_track_lastsector(d,batch_track=
! 				  cdda_sector_gettrack(d,
! 						       cursor-sector_offset)) 
! 	    + sector_offset;
  	  if(batch_last>last_sector)batch_last=last_sector;
  	}else{
  	  batch_first=first_sector;
  	  batch_last=last_sector;
  	  batch_track=-1;
  	}
+ 
+ 	if (batch_track == 0 && batch_first < 0) {
+ 	  cursor = cdda_track_firstsector(d,1) + sector_offset;
+ 	  continue;
+ 	}
  	
+ 	if(batch_first<0)
+ 	  batch_first=0;
+ 	if(batch_last<0) 
+ 	  batch_last=0;
+ 
+ 	if(batch_first>=disc_last_sector)
+ 	  batch_first=disc_last_sector;
+ 	if(batch_last>=disc_last_sector)
+ 	  batch_last=disc_last_sector;
+ 
  	callbegin=batch_first;
  	callend=batch_last;
! 
  	/* argv[optind] is the span, argv[optind+1] (if exists) is outfile */
  	
  	if(optind+1<argc){

